package ping

import (
	"fmt"
	"os/exec"
)

func Ping(destination string, options *PingOptions) (*PingResult, error) {
	options.Validate()

	params := make([]string, 0)
	params = append(params, "/C")
	params = append(params, "chcp 437")
	params = append(params, "&&")
	params = append(params, "ping")
	params = append(params, destination)
	params = append(params, fmt.Sprintf("-n %d", options.Retry))
	params = append(params, fmt.Sprintf("-w %d", options.Deadline*1000))

	pCmd := exec.Command("cmd.exe", params...)
	output, err := pCmd.CombinedOutput()
	if err != nil {
		return "", err
	}

	return parseWindowsPing(output)
}
